c  ---------------------------------------------------------------------
      function funmin ( x,n )
c  ---------------------------------------------------------------------
      implicit double precision (a-h,o-z)
      dimension x(n)
      x1 = x(1)
      x2 = x(2)
      funmin = (4 - 2.1*x1**2 + x1**4/3)*x1**2 +
     &         x1*x2 + (-4 + 4*x2**2)*x2**2
      end
c  ---------------------------------------------------------------------
      subroutine granal ( n, x, grad )
c  ---------------------------------------------------------------------
      implicit double precision (a-h,o-z)
      dimension x(n), grad(n)
      grad(1) = 8*x(1) - 8.4*x(1)**3 + 2*x(1)**5 + x(2)
      grad(2) = x(1) - 8*x(2) + 16*x(2)**3
      end
c  ---------------------------------------------------------------------
      subroutine hanal ( h, ld, n, x )
c  ---------------------------------------------------------------------
      implicit double precision (a-h,o-z)
      dimension h(ld,n), x(n)
      h(1,1) = 8 - 25.2*x(1)**2 + 10*x(1)**4
      h(2,1) = 1
      h(2,2) = 48*x(2)**2 - 8
      end
